library json_helper;

import 'dart:convert';

class JsonHelper {
  
  static int objToInt(dynamic obj) {
    return int.parse(obj.toString());
  }
  
  static double objToDouble(dynamic obj) {
    return double.parse(obj.toString());
  }
  
  static String objToString(dynamic obj) {
    return obj.toString();
  }
  
  static T getFromString<T>(String data, String path, Function parser) {
    var o = JsonHelper(data);
    return o.get(path, parser);
  }
  
  static T getFromMap<T>(Map<String, dynamic> data, String path, Function parser) {
    var o = JsonHelper.fromJson(data);
    return o.get(path, parser);
  }
  
  dynamic _jsonData;
  
  JsonHelper(String data) : this.fromJson(json.decode(data));
  
  JsonHelper.fromJson(this._jsonData);
  
  _valueForKey(dynamic data, List<String> fieldPath, Function parser) {
    if (fieldPath == null || fieldPath.isEmpty) {
      return parser(data);
    }
    String key = fieldPath[0];
    dynamic v;
    if (key.startsWith('\[')) {
      v = data[int.parse(key.substring(1, key.length - 1))];
    } else {
      v = data[key];
    }
    if (fieldPath.length > 1) {
      fieldPath.removeAt(0);
      return _valueForKey(v, fieldPath, parser);
    } else {
      if (parser != null) {
        return parser(v);
      }
      return v;
    }
  }
  
  T get<T>(String path, Function parser) {
    List<String> fieldPath;
    if (path != null) {
      fieldPath = path.split('\.');
    }
    var result = _valueForKey(_jsonData, fieldPath, parser);
    return result;
  }
  
  String toJsonString(dynamic o) {
    return json.encode(o);
  }
}